# Interface RotateHelperAbstract<OriginObject3D>`Abstract`

interface RotateHelperAbstract<OriginObject3D extends Object3D = Object3D> {
angleTips?: {
element: HTMLElement;
hide: () => void;
setLeftTop: (left: string, top: string) => void;
show: () => void;
};
xCircle?: Circle;
yCircle?: Circle;
zCircle?: Circle;
get helperObject(): Object3D;
add(...objects: Object3D[]): RotateHelperAbstract<OriginObject3D>;
addIfNotExists(
...objects: Object3D[],
): RotateHelperAbstract<OriginObject3D>;
applyHelperQuaternion(quaternion: Quaternion, origin?: Vector3): void;
applyHelperScaleMatrix4(matrix: Matrix4, origin?: Vector3): void;
disable(): void;
dispose(): void;
enable(): void;
hide(): void;
initialPosition(offset?: Vector3): void;
initQuaternion(
config?: {
xAxis?: Vector3 | (() => Vector3);
yAxis?: Vector3 | (() => Vector3);
zAxis?: Vector3 | (() => Vector3);
},
): void;
raycasterIntersectObject(
raycaster: Raycaster,
intersection?: Intersection[],
): Intersection[];
remove(...objects: Object3D[]): RotateHelperAbstract<OriginObject3D>;
removeChildren(): RotateHelperAbstract<OriginObject3D>;
removeFromParent(): RotateHelperAbstract<OriginObject3D>;
render(): void;
setHelperQuaternion(quaternion: Quaternion, origin?: Vector3): void;
setScaleByCamera(camera: PerspectiveCamera | OrthographicCamera): void;
show(): void;
showDraggingHelper(directions: Direction[]): void;
update(camera: Camera): void;
}

#### Type Parameters

- OriginObject3D extends Object3D = Object3D

#### Hierarchy (View Summary)

- BaseHelper<OriginObject3D>
  - RotateHelperAbstract

- Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:218

##### Index

### Properties

angleTips?
xCircle?
yCircle?
zCircle?

### Accessors

helperObject

### Methods

add
addIfNotExists
applyHelperQuaternion
applyHelperScaleMatrix4
disable
dispose
enable
hide
initialPosition
initQuaternion
raycasterIntersectObject
remove
removeChildren
removeFromParent
render
setHelperQuaternion
setScaleByCamera
show
showDraggingHelper
update

## Properties

### `Optional` `Abstract` angleTips

angleTips?: {
element: HTMLElement;
hide: () => void;
setLeftTop: (left: string, top: string) => void;
show: () => void;
}

- Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:222

### `Optional` `Abstract` xCircle

xCircle?: Circle

- Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:219

### `Optional` `Abstract` yCircle

yCircle?: Circle

- Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:220

### `Optional` `Abstract` zCircle

zCircle?: Circle

- Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:221

## Accessors

### helperObject

- get helperObject(): Object3D

  #### Returns Object3D

  Inherited from BaseHelper.helperObject

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:63

## Methods

### add

- add(...objects: Object3D[]): RotateHelperAbstract<OriginObject3D>

  Adds object as child of this object.

  #### Parameters

  - ...objects: Object3D[]

  #### Returns RotateHelperAbstract<OriginObject3D>

  Inherited from BaseHelper.add

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:35

### addIfNotExists

- addIfNotExists(...objects: Object3D[]): RotateHelperAbstract<OriginObject3D>

  #### Parameters

  - ...objects: Object3D[]

  #### Returns RotateHelperAbstract<OriginObject3D>

  Inherited from BaseHelper.addIfNotExists

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:41

### applyHelperQuaternion

- applyHelperQuaternion(quaternion: Quaternion, origin?: Vector3): void

  #### Parameters

  - quaternion: Quaternion
  - `Optional` origin: Vector3

  #### Returns void

  Inherited from BaseHelper.applyHelperQuaternion

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:189

### applyHelperScaleMatrix4

- applyHelperScaleMatrix4(matrix: Matrix4, origin?: Vector3): void

  #### Parameters

  - matrix: Matrix4
  - `Optional` origin: Vector3

  #### Returns void

  Inherited from BaseHelper.applyHelperScaleMatrix4

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:176

### disable

- disable(): void

  #### Returns void

  Inherited from BaseHelper.disable

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:84

### dispose

- dispose(): void

  #### Returns void

  Inherited from BaseHelper.dispose

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:197

### enable

- enable(): void

  #### Returns void

  Inherited from BaseHelper.enable

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:78

### hide

- hide(): void

  #### Returns void

  Inherited from BaseHelper.hide

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:93

### initialPosition

- initialPosition(offset?: Vector3): void

  #### Parameters

  - `Optional` offset: Vector3

  #### Returns void

  Inherited from BaseHelper.initialPosition

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:102

### initQuaternion

- initQuaternion(
  config?: {
  xAxis?: Vector3 | (() => Vector3);
  yAxis?: Vector3 | (() => Vector3);
  zAxis?: Vector3 | (() => Vector3);
  },
  ): void

  #### Parameters

  - `Optional` config: {
    xAxis?: Vector3 | (() => Vector3);
    yAxis?: Vector3 | (() => Vector3);
    zAxis?: Vector3 | (() => Vector3);
    }

  #### Returns void

  Inherited from BaseHelper.initQuaternion

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:122

### raycasterIntersectObject

- raycasterIntersectObject(
  raycaster: Raycaster,
  intersection?: Intersection[],
  ): Intersection[]

  #### Parameters

  - raycaster: Raycaster
  - intersection: Intersection[] = []

  #### Returns Intersection[]

  Inherited from BaseHelper.raycasterIntersectObject

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:98

### remove

- remove(...objects: Object3D[]): RotateHelperAbstract<OriginObject3D>

  Removes object as child of this object.

  #### Parameters

  - ...objects: Object3D[]

  #### Returns RotateHelperAbstract<OriginObject3D>

  Inherited from BaseHelper.remove

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:49

### removeChildren

- removeChildren(): RotateHelperAbstract<OriginObject3D>

  #### Returns RotateHelperAbstract<OriginObject3D>

  Inherited from BaseHelper.removeChildren

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:28

### removeFromParent

- removeFromParent(): RotateHelperAbstract<OriginObject3D>

  #### Returns RotateHelperAbstract<OriginObject3D>

  Inherited from BaseHelper.removeFromParent

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:55

### render

- render(): void

  #### Returns void

  Inherited from BaseHelper.render

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:74

### setHelperQuaternion

- setHelperQuaternion(quaternion: Quaternion, origin?: Vector3): void

  #### Parameters

  - quaternion: Quaternion
  - `Optional` origin: Vector3

  #### Returns void

  Inherited from BaseHelper.setHelperQuaternion

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:180

### setScaleByCamera

- setScaleByCamera(camera: PerspectiveCamera | OrthographicCamera): void

  #### Parameters

  - camera: PerspectiveCamera | OrthographicCamera

  #### Returns void

  Inherited from BaseHelper.setScaleByCamera

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:120

### show

- show(): void

  #### Returns void

  Inherited from BaseHelper.show

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:88

### `Abstract` showDraggingHelper

- showDraggingHelper(directions: Direction[]): void

  #### Parameters

  - directions: Direction[]

  #### Returns void

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:223

### `Abstract` update

- update(camera: Camera): void

  #### Parameters

  - camera: Camera

  #### Returns void

  - Defined in lib/plugins/Object3DHelperPlugin/Helper/BaseHelper.ts:224